/*****************************************************************************
*
* FILE NAME:		ThreadTimer.h
*
* DESCRIPTION:		RT-edge DBRei ^C}[XbhW[
*
*                   Copyright(C) 2020 Micronet Co. All Rights Reserved.
\*****************************************************************************/
#pragma once
#include <iostream>
#include <string>

#include <rtpp.h>

#include "CString.h"

using namespace std;


class CEgDBATagDB;						// "ThreadDB.h"Œ`


// ------------------------------------------------------------
// ^C}[Xbh^ONX
// ------------------------------------------------------------
class CEgDBATagTimer : public CEgDBATag
{
public:

	// ------------------------------------------------------------
	// RXgN^
	// [param]
	//		Ȃ
	// [return]
	//		Ȃ
	// [remarks]
	//		^O͈Ŏw肳ꂽ^ǑɁuTimervt܂B
	// ------------------------------------------------------------
	CEgDBATagTimer(void);

	// ------------------------------------------------------------
	// fXgN^
	// [param]
	//		Ȃ
	// [return]
	//		Ȃ
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	~CEgDBATagTimer(void);

	// ------------------------------------------------------------
	// ^O̐
	// [param]
	//		*chName ... ^O
	//		woType      ... ^O^Cv
	//		*chSource   ... f[^\[X
	//		*chComment  ... Rg
	// [return]
	//		0=I/̑=G[
	// [remarks]
	//		^O͈Ŏw肳ꂽ^ȎOɁuSERVICE.EgModbusvt܂B
	// ------------------------------------------------------------
	DWORD	fnCreate(const char *chName, WORD woType, const char *chSource = "", const char *chComment = "");

};


// ------------------------------------------------------------
// ^C}[XbhNX
// ------------------------------------------------------------
class CThreadTimer : public CIPollThread
{
public:
	// Xbh
	CString								m_srNmTh;
	// O
	CEgDBALog							m_Log;
	// Xbh
	INIT_STATE							m_enThSts;

	// ------------------------------------------------------------
	// RXgN^
	// [param]
	//		Ȃ
	// [return]
	//		Ȃ
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	CThreadTimer();

	// ------------------------------------------------------------
	// fXgN^
	// [param]
	//		Ȃ
	// [return]
	//		Ȃ
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	~CThreadTimer(void);

	// ------------------------------------------------------------
	// T[rXvpeB^O̐
	// [param]
	//		Ȃ
	// [return]
	//		0=I/̑=G[
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	DWORD	fnCreateTag();

	// ------------------------------------------------------------
	// DBXbhgK̃bNAbv
	// [param]
	//		Ȃ
	// [return]
	//		0=I/̑=G[
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	DWORD	fnLookupDBTrg();

	// ------------------------------------------------------------
	// DBXbh^ÕA^b`
	// [param]
	//		Ȃ
	// [return]
	//		0=I/̑=G[
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	DWORD	fnAttachDBTag();
	
	// ------------------------------------------------------------
	// Xbh̐
	// [param]
	//		byPrio  ... vCIeB
	//		dwCyc   ... ^OtbV(ms)
	// [return]
	//		0=I/̑=G[
	// [remarks]
	//		^C~OXbhŕKvȃp[^ݒANXCreateR[
	// ------------------------------------------------------------
	DWORD	fnCreateThread(BYTE byPrio, DWORD dwCycle);
	
	// ------------------------------------------------------------
	// XbhO
	// [param]
	//		Ȃ
	// [return]
	//		TRUE=/FALSE=s
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	virtual BOOL	InitInstance(void);

	// ------------------------------------------------------------
	// Xbhs
	// [param]
	//		Ȃ
	// [return]
	//		TRUE=Xbhp/FALSE=XbhI
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	virtual BOOL	OnPoll(void);

	// ------------------------------------------------------------
	// G[ԃ`FbN
	// [param]
	//		Ȃ
	// [return]
	//		Ȃ
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	void	OnErrCheck(void);

	// ------------------------------------------------------------
	// Xbh㏈
	// [param]
	//		Ȃ
	// [return]
	//		0=G[Ȃ/ȊO=G[
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	virtual int		ExitInstance(void);

	// ------------------------------------------------------------
	// ^OtbVJn
	// [param]
	//		Ȃ
	// [return]
	//		0=I/̑=G[
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	DWORD	fnStart();

	// ------------------------------------------------------------
	// ^OtbV~
	// [param]
	//		Ȃ
	// [return]
	//		Ȃ
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	void	fnStop();

	// ------------------------------------------------------------
	// ^OtbVXV
	// [param]
	//		Ȃ
	// [return]
	//		0=I/̑=G[
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	DWORD	fnUpdate();

private:
	// ^OtbV(ms)
	DWORD								m_dwCycle;
	// DBXbhgK
	CISemaphore							m_DBTrg;

	// ^OFN
	CEgDBATagTimer						m_tgSuspend;
	// ^OFŐṼG[R[h
	CEgDBATagTimer						m_tgLastErr;
	// ^OFDBXbhgKʒm
	CEgDBATagTimer						m_tgTrigger;
	// ^OFDBXbhx
	CEgDBATagTimer						m_tgDelay;
	// ^OFX[u[JXbhxJE^
	CEgDBATagTimer						m_tgDelayCtr;
	// ^OFғJE^
	CEgDBATagTimer						m_tgLive;
	// T[rXCWP[^F^OtbV
	CEgDBATag							m_tgIndRun;
	// T[rXCWP[^FG[
	CEgDBATag							m_tgIndError;
	// T[rXCWP[^FT[rXғJE^
	CEgDBATag							m_tgIndLive;
	// R[obNFN
	CEgDBATag							m_tgSuspendCallback;
	// DBXbhFN
	CEgDBATagDB							*m_tgSuspendDB;
	// DBXbhFڑ
	CEgDBATagDB							*m_tgConnectedDB;



};


