/*****************************************************************************
*
* FILE NAME:		DriverClient.h
*
* DESCRIPTION:	ėpINtimehCoԃC^[tF[XNCAgNX
*
* REMARKS:			̃NX̓VXeɈˑȂdg݂ō쐬Ă܂B
*
*               Copyright(C) 2020 Micronet Co. All Rights Reserved.
\*****************************************************************************/
#pragma once
#include <rtpp.h>
#include <stdio.h>
#include <string.h>
#include <syslog.h>
#include "exception.h"
#include "DriverIfMsgCarrier.h"
#include "MemoryPool.h"

// ------------------------------------------------------------
// hCoNCAgNX
// - hCoT[rXɑ΂v܂B
// ------------------------------------------------------------
class CDriverClient
{
private:
	static const int	m_NumQue = 32;			// L[̌
	static const DWORD	m_SizePacket = 0x1000;	// bZ[W̃oCgTCY
	CIObjectMbx			*m_Driver;				// ڑ̃[{bNX
	CIMemoryPool		*m_Pool;				// v[([{bNX)
	char				m_DriverName[64];		// ڑ̃[{bNX
	DWORD				m_RespTout;				// ^CAEg(ms)

public:
	bool				m_bConnected;			// ڑm@Connect~Disconnect=true
	bool				m_bRequestNow;			// v@Resuest=true

	// ------------------------------------------------------------
	// RXgN^
	// [param]
	//		Ȃ
	// [return]
	//		Ȃ
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	CDriverClient();

	// ------------------------------------------------------------
	// fXgN^
	// [param]
	//		Ȃ
	// [return]
	//		Ȃ
	// [remarks]
	//		RXgN^ŐIuWFNg폜B
	// ------------------------------------------------------------
	~CDriverClient();

	// ------------------------------------------------------------
	// [{bNX̐ڑ
	// [param]
	//		name ... [{bNX
	//				"procnamemailboxname"...vZXw ܂
	//				"mailboxname"...vZXw
	// [return]
	//		0=/ȊO=s
	// [remarks]
	//		hCoT[rX[{bNXɃbNAbvB
	// ------------------------------------------------------------
	DWORD Connect(char* name);

	// ------------------------------------------------------------
	// [{bNX̐ؒf
	// [param]
	//		Ȃ
	// [return]
	//		0=/ȊO=s
	// [remarks]
	//		ڑ̃[{bNXؒfB
	// ------------------------------------------------------------
	DWORD Disconnect();

	// ------------------------------------------------------------
	// hCoT[rX֗vB
	// [param]
	//		dwControlCode ... vR[h
	//		dwUpStreamSize ... oCgTCY 0=
	//		lpUpStream ... vf[^
	//		*dwDownStreamSize ... oCgTCY 0=(\ߗvTCYi[BʂԔ[)
	//		lpDownStream ...  f[^
	// [return]
	//		0=/ȊO=s
	// [remarks]
	//		hCoT[rX֗vB
	// ------------------------------------------------------------
	DWORD Request(DWORD dwControlCode, DWORD dwUpStreamSize, LPVOID lpUpStream, DWORD *dwDownStreamSize, LPVOID lpDownStream);

	// ------------------------------------------------------------
	// ^CAEgݒ肷
	// [param]
	//		dwRespTout ... ^CAEg
	// [return]
	//		0=/ȊO=s
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	void SetRespTout(DWORD dwRespTout);

};


