/*****************************************************************************
*
* FILE NAME:		DriverService.cpp
*
* DESCRIPTION:	ėpINtimehCoԃC^[tF[XT[rXNX
*
* REMARKS:			̃NX̓VXeɈˑȂdg݂ō쐬Ă܂B
*					VXeɈˑ鏈DriverInterfaceMsgɍ쐬ĂB
*
*               Copyright(C) 2020 Micronet Co. All Rights Reserved.
\*****************************************************************************/
#include "DriverService.h"

// ------------------------------------------------------------
// RXgN^
CDriverService::CDriverService(CDriverInterfaceMsg* param) :
	CIObjectMbxThread(),
	m_DriverIfMsg(param)
{
}

// ------------------------------------------------------------
// fXgN^
CDriverService::~CDriverService()
{
}

// ------------------------------------------------------------
// O
BOOL CDriverService::InitInstance()
{
	return CIObjectMbxThread::InitInstance();
}

// ------------------------------------------------------------
// ㏈
int CDriverService::ExitInstance()
{
	return CIObjectMbxThread::ExitInstance();
}

// ------------------------------------------------------------
// bZ[WM
BOOL CDriverService::OnReceive(CIObject * pObject, CIObject * pReply)
{
	try
	{
		CDriverIfMsgCarrier		carrier;
		RTHANDLE				ResMbx;
		RTHANDLE				theObj;
		DWORD					status;

		// MɃvt@CKp
		theObj = pObject->GetHandle();
		status = carrier.Attach(theObj);
		if (status != E_OK)
			return TRUE;

		// NCAgv̏sB
		m_DriverIfMsg->OnRequest(&carrier);

		// ԐMw肪ĂȂԐM
		if (pReply)
		{
			// mF
			if (GetRtHandleType(theObj) == SEGMENT_TYPE)
			{
				// ԑ
				ResMbx = pReply->GetHandle();
				SendRtHandle(ResMbx, theObj, 0);
			}
			else
			{
				// Av폜ꂽ\
				m_DriverIfMsg->OnError();
			}
		}

		// vCIeB̂̃XbhɃfBXpb``X^
		// vL[܂ĂƂCh΂Ȃ悤ɂz
		Sleep(0);

		return TRUE;
	}
	catch (HardwareException &e)
	{
		m_DriverIfMsg->OnTrace("Hardware exception fault");
		m_DriverIfMsg->OnTrace("%s", e.what());
		syslog(LOG_CRIT, "%s", "Hardware exception fault");
		syslog(LOG_CRIT, "%s", e.what());
		printf("Hardware exception fault");
		printf("%s", e.what());
		return FALSE;
	}
	catch (BaseException &e)
	{
		m_DriverIfMsg->OnTrace("exception fault %s", e.what());
		syslog(LOG_ERR, "exception fault %s", e.what());
		printf("exception fault %s\n", e.what());
		return FALSE;
	}
	catch (std::exception &e)
	{
		m_DriverIfMsg->OnTrace("exception fault %s\n", e.what());
		syslog(LOG_ERR, "exception fault %s", e.what());
		printf("exception fault %s\n", e.what());
		return FALSE;
	}
}

// ------------------------------------------------------------
// Xbhpn[hEFAtbNLɂB
void CDriverService::EnableHwHook()
{
	HardwareException::Hook();
}
