/*****************************************************************************
*
* FILE NAME:		EgDBA.h
*
* DESCRIPTION:		RT-edge DBRei CvOW[
*
*                   Copyright(C) 2020 Micronet Co. All Rights Reserved.
\*****************************************************************************/
#pragma once
#include <iostream>

#include <rtpp.h>

#include "CString.h"

#include "egAPI.h"

using namespace std;



// ------------------------------------------------------------
// O[o^Cv錾
// ------------------------------------------------------------
typedef enum {
	BEFORE_INIT,
	INIT_BUSY,
	INIT_DONE,
	CLEANUP_BUSY
}					INIT_STATE;

// ------------------------------------------------------------
// O[oIuWFNg
// ------------------------------------------------------------
typedef struct {
	RTHANDLE			hMain;		// CXbhRTHANDLE
	INIT_STATE			state;		// CXbh̏
	BOOLEAN				bCataloged;	// TRUE: vZX[gɃJ^OꍇTRUE
	BOOLEAN				bShutdown;	// ׂẴXbhITRUE
}					INIT_STRUCT;


// ------------------------------------------------------------
// IuWFNg
// ------------------------------------------------------------
#define	NM_EGDBA_PROC_RTANAME			"EgDBA"				// J^OFvZX
#define	NM_EGDBA_THMAIN					"MainTh"			// J^OFCXbh
#define	NM_EGDBA_THTIMER				"TimerTh"			// J^OF^C}[Xbh
#define	NM_EGDBA_THDB					"DBTh"				// J^OFDBXbh
#define	NM_EGDBA_SEMDB					"DBSem"				// J^OFDBXbhgK


// ------------------------------------------------------------
// G[R[h
// ------------------------------------------------------------
#define	ERR_EGDBA_OK							0x00000000	// IG[Ȃ
// CXbh
#define	ERR_EGDBA_DSN_NO_SET					0x01000001	// NFDBڑf[^\[X̂ݒ肳ĂȂ
#define	ERR_EGDBA_DBNAME_NO_SET					0x01000002	// NFDBڑf[^\[X̂ݒ肳ĂȂ
#define	ERR_EGDBA_CREATE_TH_TIMER				0x01000003	// ^C}[Xbh̐Ɏs܂B
#define	ERR_EGDBA_CREATE_TH_DB					0x01000004	// DBXbh̐Ɏs܂B
// R[obN
#define	ERR_EGDBA_RECV_MSG_UNKNOWN				0x02000001	// T|[g̃T[rXbZ[WM܂B
#define	ERR_EGDBA_NOTIFY_TRG_TIMER				0x02000002	// Abvf[gbZ[WgK̒ʒmɎs܂B
// ^C}[Xbh
#define	ERR_EGDBA_TRG_TIMER						0x03000001	// DBXbh̃gKʒms(E_LIMITȊO)܂B
#define	ERR_EGDBA_DETECT_SLAVE_DELAY			0x03000002	// DBXbh̒xo܂B
// DBXbh
#define	ERR_EGDBA_RECV_TRG_SLAVE				0x04000001	// DBXbhgKMs܂B
#define	ERR_EGDBA_TAG_NO_CONFIG					0x04000002	// ^Oo^Ă܂
#define	ERR_EGDBA_TAG_TYPE_NOT_SUPPORT			0x04000003	// T|[g̃f[^^o^Ă܂
#define	ERR_EGDBA_DB_CONN						0x04000004	// DBڑɎs܂
#define	ERR_EGDBA_CLEAR_SQL_RESULT				0x04000005	// SQĽʉɎs܂
#define	ERR_EGDBA_DB_TABLE_CHECK				0x04000006	// DBe[u擾Ɏs܂
#define	ERR_EGDBA_DB_TABLE_INSERT				0x04000007	// DBe[u}Ɏs܂
#define	ERR_EGDBA_DB_TABLE_DELETE				0x04000008	// DBe[u폜Ɏs܂
#define	ERR_EGDBA_DB_TABLE_CREATE				0x04000009	// DBe[uɎs܂
#define	ERR_EGDBA_DB_TABLE_UNMATCH				0x0400000A	// DBe[u\svłB
#define	ERR_EGDBA_DB_MEASURE_ID_OVER			0x0400000B	// DBő[𒴂܂
#define	ERR_EGDBA_DB_STATE_SPIN					0x04000010	// DBŃXs܂B


typedef enum {									// SQL
	EN_EGDBA_SQL_TYPE_MDB = 1,
	EN_EGDBA_SQL_TYPE_SQLServer = 2,
}	EN_EGDBA_SQL_TYPE_XXXX;

typedef enum {									// 샂[h
	EN_EGDBA_MODE_CYCLE = 1,					// 샂[hFTCN
	EN_EGDBA_MODE_DEMAND = 2,					// 샂[hFf}h
}	EN_EGDBA_MODE;

#define	MIN_CYCLE								10			// ^OtbVFŏl
#define	DEF_CYCLE								100			// ^OtbVFftHgl

#define	DEF_TIMER_PRI							170			// ^C}[XbhvCIeBFftHgl
#define	MIN_TIMER_PRI							1			// ^C}[XbhvCIeBFől
#define	MAX_TIMER_PRI							254			// ^C}[XbhvCIeBFŏl
#define	DEF_DB_PRI								171			// DBXbhvCIeBFftHg
#define	MIN_DB_PRI								1			// DBXbhvCIeBFől
#define	MAX_DB_PRI								254			// DBXbhvCIeBFŏl

#define MIN_TAG_CHECK_TIMEOUT					10			// ^Oo^`FbN^CAEg(b)Fŏl

#define	DEF_DBCON_TO							5000		// DBڑ^CAEgFftHgl


// ------------------------------------------------------------
// O[oϐ
// ------------------------------------------------------------
extern	DWORD				dwDebugFlag;							// fobOtO
extern	BYTE				byDBType;								// SQL
extern	string				srDBConDsn;								// DBڑf[^\[X
extern	string				srDBConDbName;							// DBڑT[rX/f[^x[X
extern	string				srDBConUser;							// DBڑOC[U
extern	string				srDBConPass;							// DBڑ[UpX[h
extern	WORD				woDBConTO;								// DBڑ^CAEg

extern char SERVICE_REAL_NAME[EG_MAX_SERVICENAME + 1];				// T[rX

//	bit00..07		f[^̕\
#define	IFPp		if((dwDebugFlag & 0x00000001) != 0x00000000)	// R\[o͂
#define	IFPme		if((dwDebugFlag & 0x00000002) != 0x00000000)	// ʐMTCN^C\
//	bit08..31		pFKvɂȂɎgpĂ



// ------------------------------------------------------------
// ^O
// ------------------------------------------------------------
class CEgDBATag {
public:
	// ^O
	CString								m_srName;
	// ^O^Cv
	WORD								m_woType;
	// ^OTCY
	WORD								m_woSize;
	// ^Of[^
	union
	{
		char							chVal;				// EgVtSByte
		BYTE							byVal;				// EgVtByte
		BOOL							boVal;				// EgVtBoolean
		short							shVal;				// EgVtInt16
		WORD							woVal;				// EgVtUInt16
		long32							loVal;				// EgVtInt32
		DWORD							dwVal;				// EgVtUInt32
		long64							llVal;				// EgVtInt64
		float							flVal;				// EgVtUInt64
		QWORD							qwVal;				// EgVtFloat
		double							doVal;				// EgVtDouble
	}	m_unData;

	// ------------------------------------------------------------
	// RXgN^
	// [param]
	//		Ȃ
	// [return]
	//		Ȃ
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	CEgDBATag(void);

	// ------------------------------------------------------------
	// fXgN^
	// [param]
	//		Ȃ
	// [return]
	//		Ȃ
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	~CEgDBATag(void);

	// ------------------------------------------------------------
	// ^O̐
	// [param]
	//		*chName     ... ^O
	//		boPrefix    ... true=^ȎOɁuSERVICE.EgDBAvt܂B
	// [return]
	//		0=I/̑=G[
	// [remarks]
	//		^Oݒ肵܂
	//		^O͈Ŏw肳ꂽ^ȎOɁuSERVICE.EgDBAvt܂B
	// ------------------------------------------------------------
	void	fnCreateName(const char *chName, bool boPrefix);

	// ------------------------------------------------------------
	// ^O̐
	// [param]
	//		*chName     ... ^O
	//		woType      ... ^O^Cv
	//		*chSource   ... f[^\[X
	//		*chComment  ... Rg
	//		boPrefix    ... true=^ȎOɁuSERVICE.EgDBAvt܂B
	// [return]
	//		0=I/̑=G[
	// [remarks]
	//		VKRTCDɃ^O𐶐܂
	//		^O͈Ŏw肳ꂽ^ȎOɁuSERVICE.EgDBAvt܂B
	// ------------------------------------------------------------
	DWORD	fnCreate(const char *chName, WORD woType, const char *chSource = "", const char *chComment = "", bool boPrefix = true);

	// ------------------------------------------------------------
	// ^O̐ݒ
	// [param]
	//		*chName     ... ^O
	//		boPrefix    ... true=^ȎOɁuSERVICE.EgDBAvt܂B
	// [return]
	//		0=I/̑=G[
	// [remarks]
	//		^Oݒ肵܂
	//		^O͈Ŏw肳ꂽ^ȎOɁuSERVICE.EgDBAvt܂B
	// ------------------------------------------------------------
	DWORD	fnAttach(const char *chName, bool boPrefix = true);

	// ------------------------------------------------------------
	// ^O̓ǂݍ
	// [param]
	//		Ȃ
	// [return]
	//		0=I/̑=G[
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	DWORD	fnRead();

	// ------------------------------------------------------------
	// ^Ȍ
	// [param]
	//		Ȃ
	// [return]
	//		0=I/̑=G[
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	DWORD	fnWrite();

private:
	// ------------------------------------------------------------
	// ^OTCY̎擾
	// [param]
	//		*chName     ... ^O
	//		woType      ... ^O^Cv
	// [return]
	//		^OTCY
	// [remarks]
	//		^O^Cv^OTCY擾܂B
	// ------------------------------------------------------------
	WORD	fnGetSize(WORD woType);

};



// ------------------------------------------------------------
// O
// ------------------------------------------------------------
class CEgDBALog
{
public:
	// IuWFNg
	CString								m_srObj;
	// bZ[W
	CString								m_srMsg;

	// ------------------------------------------------------------
	// RXgN^
	// [param]
	//		Ȃ
	// [return]
	//		Ȃ
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	CEgDBALog(void);

	// ------------------------------------------------------------
	// fXgN^
	// [param]
	//		Ȃ
	// [return]
	//		Ȃ
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	~CEgDBALog(void);

	// ------------------------------------------------------------
	// Oo
	// [param]
	//		*chMode ... Oo͗p`
	//		dwLine  ... s
	// [return]
	//		Ȃ
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	void fnPirnt(const char *chMode, DWORD dwLine);

};


