/*****************************************************************************
*
* FILE NAME:		ThreadDB.cpp
*
* DESCRIPTION:		RT-edge DBRei DBXbhW[
*
*                   Copyright(C) 2020 Micronet Co. All Rights Reserved.
\*****************************************************************************/

#include "EgDBA.h"
#include "ThreadDB.h"


// ------------------------------------------------------------
// RXgN^
CEgDBATagDB::CEgDBATagDB()
{
}

// ------------------------------------------------------------
// fXgN^
CEgDBATagDB::~CEgDBATagDB(void)
{
}

// ------------------------------------------------------------
// ^O̐
DWORD	CEgDBATagDB::fnCreate(const char *chName, WORD woType, const char *chSource, const char *chComment)
{
	CString			srName;
	srName.Format("%s.DB", chName);
	return CEgDBATag::fnCreate(srName.c_str(), woType, chSource, chComment);
}

// ------------------------------------------------------------
// ^ÕA^b`
void	CEgDBATagDB::fnAttach(const char *chName)
{
	CString			srName;
	srName.Format("%s.DB", chName);
	CEgDBATag::fnAttach(srName.c_str());
}


// ------------------------------------------------------------
// RXgN^
CEgDBATagRef::CEgDBATagRef()
{
}

// ------------------------------------------------------------
// fXgN^
CEgDBATagRef::~CEgDBATagRef(void)
{

}


// ------------------------------------------------------------
// RXgN^
CThreadDB::CThreadDB(void)
{
	// XbhXe[^XXV
	m_enThSts = BEFORE_INIT;

}

// ------------------------------------------------------------
// fXgN^
CThreadDB::~CThreadDB()
{
}

// ------------------------------------------------------------
// T[rXvpeB^O̐
DWORD	CThreadDB::fnCreateTag()
{

	// OIuWFNg̏
	m_Log.m_srObj.Format("DB");

	// ------------------------------------------------------------
	// ^ÕA^b`F^Oo^`FbN^CAEg(b)
	m_tgTagCheckTimeout.fnAttach("TagCheckTimeout");

	// ------------------------------------------------------------
	// ^ÕA^b`FDBe[u݂ꍇ̏
	m_tgTableDelete.fnAttach("TableDelete");

	// ------------------------------------------------------------
	// ^ÕA^b`FDBe[u\sv̏ꍇ̏
	m_tgTableUnmatch.fnAttach("TableUnmatch");

	// ------------------------------------------------------------
	// ^ÕA^b`FDBe[uő[
	m_tgTableRecMax.fnAttach("TableRecMax");

	// ------------------------------------------------------------
	// ^O̐FN
	m_tgSuspend.fnCreate("Suspend", EgVtBoolean, "", "true = run / false = suspend");

	// ------------------------------------------------------------
	// ^O̐FŐṼG[R[h
	m_tgLastErr.fnCreate("LastErr", EgVtUInt32, "", "");

	// ------------------------------------------------------------
	// ^O̐FRSI-MODBUS̃G[R[h
	m_tgDBAErr.fnCreate("DBAErr", EgVtInt32, "", "");

	// ------------------------------------------------------------
	// ^O̐FғJE^
	m_tgLive.fnCreate("Live", EgVtUInt32, "", "");

	// ------------------------------------------------------------
	// ^O̐FғJE^
	m_tgState.fnCreate("State", EgVtUInt32, "", "");

	// ------------------------------------------------------------
	// ^O̐Fڑ
	m_tgConnected.fnCreate("Connected", EgVtBoolean, "", "true = connected / false = disconnected");

	// ------------------------------------------------------------
	// ^O̐FDBڑ
	m_tgConnectedOpen.fnCreate("ConnectedOpen", EgVtUInt32, "", "");

	// ------------------------------------------------------------
	// ^O̐FDBڑ
	m_tgConnectedSucc.fnCreate("ConnectedSucc", EgVtUInt32, "", "");

	// ------------------------------------------------------------
	// ^O̐FDBڑs
	m_tgConnectedFail.fnCreate("ConnectedFail", EgVtUInt32, "", "");

	// ------------------------------------------------------------
	// ^O̐FDBڑؒf
	m_tgConnectedClose.fnCreate("ConnectedClose", EgVtUInt32, "", "");

	// ------------------------------------------------------------
	// ^O̐FϒʐMTCN^C(ms)
	m_tgCycletime.fnCreate("Cycletime", EgVtFloat, "", "(ms)");

	// ------------------------------------------------------------
	// ^O̐FŒZʐMTCN^C(ms)
	m_tgCyclemin.fnCreate("Cyclemin", EgVtFloat, "", "(ms)");

	// ------------------------------------------------------------
	// ^O̐FŒʐMTCN^C(ms)
	m_tgCyclemax.fnCreate("Cyclemax", EgVtFloat, "", "(ms)");

	// ------------------------------------------------------------
	// ^O̐FvId
	m_tgMeasureId.fnCreate("MeasureId", EgVtInt32, "", "");

	return ERR_EGDBA_OK;
}

// ------------------------------------------------------------
// Z}tHXbh̐
DWORD	CThreadDB::fnCreateThread(BYTE byPrio)
{
	// Xbh̐
	m_srNmTh.Format("%s", NM_EGDBA_THDB);

	// Z}tH̐
	m_srNmSem.Format("%s", NM_EGDBA_SEMDB);

	// NXR[
	//  X^bNTCYftHgl(0x1000)ɂہADBe[uSQLPageFault߁A
	//  X^bNTCY𑝂₵Ă܂BPageFaultꍇ̓X^bNTCY𑝂₵ĂB
	return CISemaphoreThread::Create((char*)m_srNmTh.c_str(), (char*)m_srNmSem.c_str(), 1, byPrio, 0x2000);
}

// ------------------------------------------------------------
// XbhO
BOOL	CThreadDB::InitInstance(void)
{

	// XbhXe[^XXV
	m_enThSts = INIT_DONE;

	// DBԑJځFsJn҂
	fnChangeState(EN_EgDBA_DB_STATE_WaitRun);

	// NXR[
	return CISemaphoreThread::InitInstance();
}

// ------------------------------------------------------------
// Xbhs
BOOL	CThreadDB::DoForever(void)
{
	// NXR[
	return CISemaphoreThread::DoForever();
}

// ------------------------------------------------------------
// gKM
BOOL	CThreadDB::OnReceive()
{
	DWORD			dwRet = ERR_EGDBA_OK;					// ߂l

	// ------------------------------------------------------------
	// ʐMTCN^CJn
	// ------------------------------------------------------------
	m_perfComm.Start();											// ptH[}XvJn

	// ------------------------------------------------------------
	// [JXbhғJE^CNg
	// ------------------------------------------------------------
	m_tgLive.m_unData.dwVal++;
	m_tgLive.fnWrite();											// ^Ȍ

	// ------------------------------------------------------------
	// DBԑJ
	// ------------------------------------------------------------
	dwRet = fnStateMachine();
	if (dwRet != ERR_EGDBA_OK)								// ԑJڎs
	{
		printf("E$[%04d]%s %s\n", __LINE__, m_Log.m_srObj.c_str(), m_Log.m_srMsg.c_str());
		// G[R[ho
		m_Log.m_srMsg.Format("LastError = 0x%08X, DBAError = %d", m_tgLastErr.m_unData.dwVal, m_tgDBAErr.m_unData.loVal);
		m_Log.fnPirnt(EG_LOG_ERR, __LINE__);
		printf("E$[%04d]%s %s\n", __LINE__, m_Log.m_srObj.c_str(), m_Log.m_srMsg.c_str());
		// CXbhɑ΂N[Abvv܂
		RTHANDLE		hDelMbx;
		DWORD			dwTerminate;
		hDelMbx = LookupRtHandle(NULL_RTHANDLE, "R?EXIT_MBOX", 5000);
		dwTerminate = TERMINATE;
		SendRtData(hDelMbx, &dwTerminate, 4);
		m_Log.m_srMsg.Format("Suspend Thead");
		m_Log.fnPirnt(EG_LOG_DBG, __LINE__);
		m_tgSuspend.m_unData.boVal = TRUE;					// NԍXV
		m_tgSuspend.fnWrite();								// ^Ȍ
		SuspendThread();									// g̃XbhTXyh
	}

	// ------------------------------------------------------------
	// ʐMTCN^CXV
	// ------------------------------------------------------------
	m_perfComm.Stop();											// ptH[}Xv~
	m_tgCycletime.m_unData.flVal = (float)(m_perfComm.GetAve() / 1000);	// ϒʐMTCN^C̍XV
	m_tgCycletime.fnWrite();									// ^Ȍ
	m_tgCyclemin.m_unData.flVal = (float)(m_perfComm.GetMin() / 1000);	// ŒZʐMTCN^C̍XV
	m_tgCyclemin.fnWrite();										// ^Ȍ
	m_tgCyclemax.m_unData.flVal = (float)(m_perfComm.GetMax() / 1000);	// ŒʐMTCN^C̍XV
	m_tgCyclemax.fnWrite();										// ^Ȍ

	IFPme{
		// ʐMTCN^C\
		printf("I$[%04d]DB cycle avg=%.3fms min=%.3fms max=%.3fms \n", __LINE__, 
				m_tgCycletime.m_unData.flVal, m_tgCyclemin.m_unData.flVal, m_tgCyclemax.m_unData.flVal);
	}

	return TRUE;		// M
}


// ------------------------------------------------------------
// ԑJ
// [param]
//		dwState ... Jڌ̏
//		boPrint ... true=Oo͂/false=Oo͂Ȃ
// [return]
//		0=I/̑=G[
// [remarks]
//		Ȃ
// ------------------------------------------------------------
void	CThreadDB::fnChangeState(DWORD dwState, bool boPrint)
{

	if (m_tgState.m_unData.dwVal == dwState) { return; }    // ύXȂ͖
	
	if (true == boPrint)									// Oo͂
	{
		m_Log.m_srMsg.Format("Change State %02d -> %02d", m_tgState.m_unData.dwVal, dwState);
		m_Log.fnPirnt(EG_LOG_OPE, __LINE__);
	}

	m_tgState.m_unData.dwVal = dwState;						// Ԃ̍XV
	m_tgState.fnWrite();									// ^Ȍ
}

// ------------------------------------------------------------
// DBԑJ
DWORD	CThreadDB::fnStateMachine()
{
	DWORD			dwRet = ERR_EGDBA_OK;					// ߂l
	DWORD			dwLpCnt = 0;							// [v
	DWORD			dwLpMax = 100;							// ő僋[v
	bool			boLpCont = true;						// [v̌p true=[vp / false = [vI
	int				i;										// [vJEg
	bool			boFind;									// (true=o/false=o)
	int				inRet;
	WORD			woType;
	WORD			woSize;
	bool			boCheckErr;								// `FbN(true=ُ/false=)
	CString			srSql;									// SQL
	CString			srSqlCol;								// SQL
	CString			srSqlVal;								// SQLl
	CString			srTmp;									// ꎞIȒl
	DWORD			dwRecCnt;								// 擾R[h
	int				inSqlNo;								// SQLǗԍ
	long			loRtnVal;								// 擾
	char			chRtnVal[64];							// 擾
	size_t			szLp;									// [vJEg

	CEgDBATagRef	*clTagRef;								// TagRef

	while (true)
	{
		// ========================================
		// ݂DBԂŕ
		switch (m_tgState.m_unData.dwVal)
		{
		// ========================================
		// sJn҂
		case EN_EgDBA_DB_STATE_WaitRun:
			// TagRefs_OUT̔
			if (0 < egTagRefs_OUT_Count)
			{
				// ^O
				for (i = 0; i < egTagRefs_OUT_Count; i++)
				{
					// ^OXg̐
					clTagRef = new CEgDBATagRef();
					clTagRef->m_tgTag.fnAttach(egTagRefs_OUT[i].Name, false);
					m_TagRefsOut.push_back(*clTagRef);
				}
				for (szLp = 0; szLp < m_TagRefsOut.size(); szLp++)
				{
					m_Log.m_srMsg.Format("Tag[%04d] %s Type=%d Size=%d", szLp,
											m_TagRefsOut[szLp].m_tgTag.m_srName.c_str(),
											m_TagRefsOut[szLp].m_tgTag.m_woType,
											m_TagRefsOut[szLp].m_tgTag.m_woSize);
					m_Log.fnPirnt(EG_LOG_DBG, __LINE__);
				}
				m_swBase.Start();												// ԃX^[g
				fnChangeState(EN_EgDBA_DB_STATE_TagRefsOUTCheck);				// DBԑJځFTagRefs_OUT`FbN
				boLpCont = true;												// [vԁFp
				dwRet = ERR_EGDBA_OK;											// I
			}
			else
			{
				// ^OȂ
				// DBԑJځFύXȂ
				boLpCont = false;												// [vԁFI
				m_tgLastErr.m_unData.dwVal = ERR_EGDBA_TAG_NO_CONFIG;			// ŐVG[R[hXV
				m_tgLastErr.fnWrite();											// ^Ȍ
				dwRet = m_tgLastErr.m_unData.dwVal;								// G[
				m_Log.m_srMsg.Format("Failed: Tag No Config 0x%08X", m_tgLastErr.m_unData.dwVal);
				m_Log.fnPirnt(EG_LOG_ERR, __LINE__);
			}
			break;

		// ========================================
		// TagRefs_OUT`FbN
		case EN_EgDBA_DB_STATE_TagRefsOUTCheck:
			// ɑJڂFꂽ^OXg̃^CvATCYSĐݒ肳ꂽ(0ȊO)
			boFind = true;														// ftHg͌oς
			// ----------------------------------------
			// ^O^Cv`FbN
			for (szLp = 0; szLp < m_TagRefsOut.size(); szLp++)
			{
				// ^O^Cv
				if (m_TagRefsOut[szLp].m_tgTag.m_woType != EgVtEmpty)
				{
					// ^Cvݒς݂̂ߎ̃^OXg
					continue;
				}
				// ^O^Cv̎擾
				// EgDBɋNꂽReĩ^OQƂہA
				// EgDBŊmۂTagRefs_OUTɂ̓^Cv񂪃ZbgĂȂꍇ邽߁A
				// TagRefs_OUTłȂڃ^OQƂB
				inRet = EgTagGetProperty(m_TagRefsOut[szLp].m_tgTag.m_srName.c_str(), "Type", &woType, sizeof(woType));
				if (0 == inRet)
				{
					// ^O^Cv擾
					// 擾ʂ̔
					if (EgVtEmpty != woType)
					{
						// 擾
						m_TagRefsOut[szLp].m_tgTag.m_woType = woType;
					}
					else
					{
						// Empty͎擾s
						boFind = false;
					}
				}
				else
				{
					// ^O^Cv擾s
					boFind = false;
				}
			}
			// ----------------------------------------
			// ^OTCY`FbN
			for (szLp = 0; szLp < m_TagRefsOut.size(); szLp++)
			{
				// TCY̐ݒ
				if (m_TagRefsOut[szLp].m_tgTag.m_woSize != 0)
				{
					// TCYݒς݂̂ߎ̃^OXg
					continue;
				}

				// ^Õf[^TCY̎擾
				// EgDBɋNꂽReĩ^OQƂہA
				// EgDBŊmۂTagRefs_OUTɂ̓TCY񂪃ZbgĂȂꍇ邽߁A
				// TagRefs_OUTłȂڃ^OQƂB
				inRet = EgTagGetProperty(m_TagRefsOut[szLp].m_tgTag.m_srName.c_str(), "Size", &woSize, sizeof(woSize));
				if (0 == inRet)
				{
					// ^O擾
					// 擾ʂ̔
					if (0 != woSize)
					{
						// 擾
						m_TagRefsOut[szLp].m_tgTag.m_woSize = woSize;
					}
					else
					{
						// TCY0͎擾s
						boFind = false;
					}
				}
				else
				{
					// 擾s
					boFind = false;
				}
			}
			// ʔ
			if (true == boFind)
			{
				// SăTCYݒ肳ꂽ
				for (szLp = 0; szLp < m_TagRefsOut.size(); szLp++)
				{
					m_Log.m_srMsg.Format("Tag[%04d] %s Type=%d Size=%d", szLp,
											m_TagRefsOut[szLp].m_tgTag.m_srName.c_str(),
											m_TagRefsOut[szLp].m_tgTag.m_woType,
											m_TagRefsOut[szLp].m_tgTag.m_woSize);
					m_Log.fnPirnt(EG_LOG_DBG, __LINE__);
				}
				fnChangeState(EN_EgDBA_DB_STATE_TypeCheck);						// DBԑJځFf[^^`FbN
				boLpCont = true;												// [vԁFp
				dwRet = ERR_EGDBA_OK;											// I
			}
			else
			{
				// ܂TCYݒ肳ĂȂ
				fnChangeState(EN_EgDBA_DB_STATE_TagRefsOUTRetry, false);		// DBԑJځFTagRefs_OUT`FbNgC
				boLpCont = true;												// [vԁFp
				dwRet = ERR_EGDBA_OK;											// I
			}
			break;

		// ========================================
		// DBI[v
		case EN_EgDBA_DB_STATE_DBOpen:
			m_tgConnectedOpen.m_unData.dwVal++;									// I[v񐔃CNg
			m_tgConnectedOpen.fnWrite();										// ^Ȍ
			// f[^x[XƂ̐ڑJn
			inRet = RtdbConnect((char*)srDBConDsn.c_str(), (char*)srDBConDbName.c_str(),
								(char*)srDBConUser.c_str(), (char*)srDBConPass.c_str(),
								&m_hnCnDb, woDBConTO);
			if (inRet >= 0)
			{
				// ڑ
				m_Log.m_srMsg.Format("Conneted");
				m_Log.fnPirnt(EG_LOG_OPE, __LINE__);
				m_tgConnectedSucc.m_unData.dwVal++;								// ڑ񐔃CNg
				m_tgConnectedSucc.fnWrite();									// ^Ȍ
				m_tgConnected.m_unData.boVal = TRUE;							// ڑԍXV
				m_tgConnected.fnWrite();										// ^Ȍ
				fnChangeState(EN_EgDBA_DB_STATE_DBTableExist);					// DBԑJځFDBe[u݊mF
				boLpCont = true;												// [vԁFp
				dwRet = ERR_EGDBA_OK;											// I
			}
			else
			{
				// ڑsFvIȃG[̂ߏԑJڂُ͈I
				m_Log.m_srMsg.Format("Failed: DB Open %d", inRet);
				m_Log.fnPirnt(EG_LOG_ERR, __LINE__);
				m_tgDBAErr.m_unData.dwVal = inRet;								// G[R[h̍XV
				m_tgDBAErr.fnWrite();											//  ^Ȍ
				m_tgLastErr.m_unData.dwVal = ERR_EGDBA_DB_CONN;					// ŐVG[R[hXV
				m_tgLastErr.fnWrite();											// ^Ȍ
				m_tgConnectedFail.m_unData.dwVal++;								// s񐔃CNg
				m_tgConnectedFail.fnWrite();									// ^Ȍ
				// DBԑJځFȂ
				boLpCont = false;												// [vԁFI
				dwRet = m_tgLastErr.m_unData.dwVal;								// ُI
			}
			break;

		// ========================================
		// DBe[u݊mF
		case EN_EgDBA_DB_STATE_DBTableExist:
			// SQL̐
			srSql.Format("select * from %s", srDBConDbName.c_str());
			// SELECT̎s
			inSqlNo = RtdbCreateDataTable(m_hnCnDb, (char*)srSql.c_str(), woDBConTO, &dwRecCnt);
			if (0 <= inSqlNo)
			{
				// sFDBe[u
				m_Log.m_srMsg.Format("Exist %s", srDBConDbName.c_str());
				m_Log.fnPirnt(EG_LOG_OPE, __LINE__);
				// SQĽʂ
				inRet = RtdbClearSqlResult(m_hnCnDb, inSqlNo, woDBConTO);
				if (0 == inRet)
				{
					// 
					fnChangeState(EN_EgDBA_DB_STATE_DBTableRecCheck);			// DBԑJځF擾R[h
					boLpCont = true;											// [vԁFp
					dwRet = ERR_EGDBA_OK;										// I
				}
				else
				{
					// sFvIȃG[̂ߏԑJڂُ͈I
					m_Log.m_srMsg.Format("Failed: Clear Sql Result %d", inRet);
					m_Log.fnPirnt(EG_LOG_ERR, __LINE__);
					m_tgDBAErr.m_unData.dwVal = inRet;								// G[R[h̍XV
					m_tgDBAErr.fnWrite();											//  ^Ȍ
					m_tgLastErr.m_unData.dwVal = ERR_EGDBA_CLEAR_SQL_RESULT;		// ŐVG[R[hXV
					m_tgLastErr.fnWrite();											// ^Ȍ
					// DBԑJځFȂ
					boLpCont = false;												// [vԁFI
					dwRet = m_tgLastErr.m_unData.dwVal;								// ُI
				}
			}
			else
			{
				// ssFDBe[uȂ
				m_Log.m_srMsg.Format("No Exist %s", srDBConDbName.c_str());
				m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
				fnChangeState(EN_EgDBA_DB_STATE_DBTableCreate);					// DBԑJځFDBe[u쐬
				boLpCont = true;												// [vԁFp
				dwRet = ERR_EGDBA_OK;											// I
			}
			break;

		// ========================================
		// DBe[u\mF
		case EN_EgDBA_DB_STATE_DBTableConfigCheck:
			// SQL̐
			srSql.Format("select * from %s order by %s desc", srDBConDbName.c_str(), NM_EgDBA_TABLE_MEASURE_ID);
			// SELECT̎s
			inSqlNo = RtdbCreateDataTable(m_hnCnDb, (char*)srSql.c_str(), woDBConTO, &dwRecCnt);
			if (0 <= inSqlNo)
			{
				// sFDBe[u
				// J̑݊mF
				boCheckErr = false;													// ftHg̓`FbNʐ

				// J"measure_id"̒l擾
				inRet = RtdbGetLong(m_hnCnDb, inSqlNo, 0, NM_EgDBA_TABLE_MEASURE_ID, &loRtnVal, woDBConTO);
				if (0 == inRet)
				{
					// 擾
					m_Log.m_srMsg.Format("last %s is %d", NM_EgDBA_TABLE_MEASURE_ID, loRtnVal);
					m_Log.fnPirnt(EG_LOG_DBG, __LINE__);
					m_tgMeasureId.m_unData.loVal = loRtnVal + 1;					// vID̍XV
					m_tgMeasureId.fnWrite();										// ^Ȍ
				}
				else
				{
					// 擾s
					m_Log.m_srMsg.Format("%s is not defined. ret=%d", NM_EgDBA_TABLE_MEASURE_ID, inRet);
					m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
					boCheckErr = true;												// J"measure_id"`
				}

				// J"measure_date"̒l擾
				inRet = RtdbGetString(m_hnCnDb, inSqlNo, 0, NM_EgDBA_TABLE_MEASURE_DATE, chRtnVal, sizeof(chRtnVal), woDBConTO);
				if (0 == inRet)
				{
					// 擾
					m_Log.m_srMsg.Format("last %s is %s", NM_EgDBA_TABLE_MEASURE_DATE, chRtnVal);
					m_Log.fnPirnt(EG_LOG_DBG, __LINE__);
				}
				else
				{
					// 擾s
					m_Log.m_srMsg.Format("%s is not defined. ret=%d", NM_EgDBA_TABLE_MEASURE_DATE, inRet);
					m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
					boCheckErr = true;												// J"measure_date"`
				}
				
				// J"measure_msec"̒l擾
				inRet = RtdbGetLong(m_hnCnDb, inSqlNo, 0, NM_EgDBA_TABLE_MEASURE_MSEC, &loRtnVal, woDBConTO);
				if (0 == inRet)
				{
					// 擾
					m_Log.m_srMsg.Format("last %s is %d", NM_EgDBA_TABLE_MEASURE_MSEC, loRtnVal);
					m_Log.fnPirnt(EG_LOG_DBG, __LINE__);
				}
				else
				{
					// 擾s
					m_Log.m_srMsg.Format("%s is not defined. ret=%d", NM_EgDBA_TABLE_MEASURE_MSEC, inRet);
					m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
					boCheckErr = true;												// J"measure_msec"`
				}

				// TagRefsɒ`ꂽ^OJɒ`Ă邩̔
				for (szLp = 0; szLp < m_TagRefsOut.size(); szLp++)
				{
					// ^Oo^mF
					if (m_TagRefsOut[szLp].m_tgTag.m_woSize == 0) { continue; }		// ^OTCYݒ͏O

					// l̎擾
					inRet = RtdbGetLong(m_hnCnDb, inSqlNo, 0, (char*)m_TagRefsOut[szLp].m_tgTag.m_srName.c_str(), &loRtnVal, woDBConTO);
					if (0 == inRet)
					{
						// 擾
						m_Log.m_srMsg.Format("last %s is %d", m_TagRefsOut[szLp].m_tgTag.m_srName.c_str(), loRtnVal);
						m_Log.fnPirnt(EG_LOG_DBG, __LINE__);
					}
					else
					{
						// 擾s
						m_Log.m_srMsg.Format("%s is not defined. ret=%d", m_TagRefsOut[szLp].m_tgTag.m_srName.c_str(), inRet);
						m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
						boCheckErr = true;												// J`
					}
				}

				// SQĽʂ
				inRet = RtdbClearSqlResult(m_hnCnDb, inSqlNo, woDBConTO);
				if (0 == inRet)
				{
					// 
					// `FbNʔ
					if (true == boCheckErr)
					{
						// ُFDBe[u\sv
						fnChangeState(EN_EgDBA_DB_STATE_DBTableConfigUnmatch);		// DBԑJځFDBe[u\sv
						boLpCont = true;											// [vԁFp
						dwRet = ERR_EGDBA_OK;										// I
					}
					else
					{
						// FDBe[u\v
						fnChangeState(EN_EgDBA_DB_STATE_DBTableConfigMatch);		// DBԑJځFDBe[u\v
						boLpCont = true;											// [vԁFp
						dwRet = ERR_EGDBA_OK;										// I
					}
				}
				else
				{
					// sFvIȃG[̂ߏԑJڂُ͈I
					m_Log.m_srMsg.Format("Failed: Clear Sql Result %d", inRet);
					m_Log.fnPirnt(EG_LOG_ERR, __LINE__);
					m_tgDBAErr.m_unData.dwVal = inRet;								// G[R[h̍XV
					m_tgDBAErr.fnWrite();											//  ^Ȍ
					m_tgLastErr.m_unData.dwVal = ERR_EGDBA_CLEAR_SQL_RESULT;		// ŐVG[R[hXV
					m_tgLastErr.fnWrite();											// ^Ȍ
					// DBԑJځFȂ
					boLpCont = false;												// [vԁFI
					dwRet = m_tgLastErr.m_unData.dwVal;								// ُI
				}
			}
			else
			{
				// ss
				m_Log.m_srMsg.Format("Select %s ret=%d", srDBConDbName.c_str(), inSqlNo);
				m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
				fnChangeState(EN_EgDBA_DB_STATE_DBTableDelete);				// DBԑJځFDBe[u폜
				boLpCont = true;											// [vԁFp
				dwRet = ERR_EGDBA_OK;										// I
			}
			break;

		// ========================================
		// DBe[u\v
		case EN_EgDBA_DB_STATE_DBTableConfigMatch:
			// DBe[u폜
			if (TRUE == m_tgTableDelete.m_unData.boVal)
			{
				// DBe[u폜w肠
				fnChangeState(EN_EgDBA_DB_STATE_DBTableDelete);				// DBԑJځFDBe[u폜
				boLpCont = true;											// [vԁFp
				dwRet = ERR_EGDBA_OK;										// I
			}
			else
			{
				// DBe[u폜wȂ
				fnChangeState(EN_EgDBA_DB_STATE_MeasureIdCheck);			// DBԑJځFID`FbN
				boLpCont = true;											// [vԁFp
				dwRet = ERR_EGDBA_OK;										// I
			}
			break;

		// ========================================
		// DBe[u\sv
		case EN_EgDBA_DB_STATE_DBTableConfigUnmatch:
			// DBe[u폜
			if (TRUE == m_tgTableUnmatch.m_unData.boVal)
			{
				// DBe[u폜w肠
				fnChangeState(EN_EgDBA_DB_STATE_DBTableDelete);				// DBԑJځFDBe[u폜
				boLpCont = true;											// [vԁFp
				dwRet = ERR_EGDBA_OK;										// I
			}
			else
			{
				// DBe[u폜wȂ
				// DBԑJځFύXȂ
				boLpCont = false;												// [vԁFI
				m_tgLastErr.m_unData.dwVal = ERR_EGDBA_DB_TABLE_UNMATCH;		// ŐVG[R[hXV
				m_tgLastErr.fnWrite();											// ^Ȍ
				dwRet = m_tgLastErr.m_unData.dwVal;								// G[
				m_Log.m_srMsg.Format("Failed: Table Column Unmatch");
				m_Log.fnPirnt(EG_LOG_ERR, __LINE__);
			}
			break;

		// ========================================
		// DBe[u폜
		case EN_EgDBA_DB_STATE_DBTableDelete:
			// SQL̐
			srSql.Format("drop table %s", srDBConDbName.c_str());
			// SQL̎s
			inRet = RtdbExecuteSql(m_hnCnDb, (char*)srSql.c_str(), woDBConTO);
			if (0 == inRet)
			{
				// s
				m_Log.m_srMsg.Format("Delete %s", srDBConDbName.c_str());
				m_Log.fnPirnt(EG_LOG_OPE, __LINE__);
				fnChangeState(EN_EgDBA_DB_STATE_DBTableCreate);				// DBԑJځFDBe[u
				boLpCont = true;											// [vԁFp
			}
			else
			{
				// ss
				// DBe[u폜Ɏs܂
				m_Log.m_srMsg.Format("Failed: Table Delete %d", inRet);
				m_Log.fnPirnt(EG_LOG_ERR, __LINE__);
				m_tgDBAErr.m_unData.dwVal = inRet;								// G[R[h̍XV
				m_tgDBAErr.fnWrite();											//  ^Ȍ
				m_tgLastErr.m_unData.dwVal = ERR_EGDBA_DB_TABLE_DELETE;			// ŐVG[R[hXV
				m_tgLastErr.fnWrite();											// ^Ȍ
				// DBԑJځFȂ
				boLpCont = false;												// [vԁFI
				dwRet = m_tgLastErr.m_unData.dwVal;								// ُI
			}
			break;

		// ========================================
		// DBe[u
		case EN_EgDBA_DB_STATE_DBTableCreate:
			// SQL̐
			srSqlCol = "";
			// SQLʂŕ
			switch (byDBType)
			{
			case EN_EGDBA_SQL_TYPE_MDB:					// MDB
			case EN_EGDBA_SQL_TYPE_SQLServer:			// SQLServer
				// "measure_id", "measure_date", "measure_msec"
				srTmp.Format("%s integer primary key, %s datetime, %s integer, ",
								NM_EgDBA_TABLE_MEASURE_ID, NM_EgDBA_TABLE_MEASURE_DATE, NM_EgDBA_TABLE_MEASURE_MSEC);
				srSqlCol += srTmp;
				// ^O
				for (szLp = 0; szLp < m_TagRefsOut.size(); szLp++)
				{
					srTmp.Format("%s integer", m_TagRefsOut[szLp].m_tgTag.m_srName.c_str());
					// f[^^ŕ
					switch (m_TagRefsOut[szLp].m_tgTag.m_woType)
					{
					case EgVtBoolean:	srTmp.Format("%s integer",	m_TagRefsOut[szLp].m_tgTag.m_srName.c_str());	break;
					case EgVtSByte:		srTmp.Format("%s integer",	m_TagRefsOut[szLp].m_tgTag.m_srName.c_str());	break;
					case EgVtByte:		srTmp.Format("%s integer",	m_TagRefsOut[szLp].m_tgTag.m_srName.c_str());	break;
					case EgVtInt16:		srTmp.Format("%s integer",	m_TagRefsOut[szLp].m_tgTag.m_srName.c_str());	break;
					case EgVtUInt16:	srTmp.Format("%s integer",	m_TagRefsOut[szLp].m_tgTag.m_srName.c_str());	break;
					case EgVtInt32:		srTmp.Format("%s integer",	m_TagRefsOut[szLp].m_tgTag.m_srName.c_str());	break;
					case EgVtFloat:		srTmp.Format("%s real",		m_TagRefsOut[szLp].m_tgTag.m_srName.c_str());	break;
					case EgVtDouble:	srTmp.Format("%s real",		m_TagRefsOut[szLp].m_tgTag.m_srName.c_str());	break;
					default:			srTmp.Format("%s integer",	m_TagRefsOut[szLp].m_tgTag.m_srName.c_str());	break;
					}
					// ^Ot
					srSqlCol += srTmp;
					// ŏI^Oǂ̔
					if ((szLp + 1) < m_TagRefsOut.size())
					{
						srSqlCol += ", ";						// ŏI^OłȂ߃J}ǉ
					}
				}
				// ^O
				srSql.Format("create table %s (%s)", srDBConDbName.c_str(), srSqlCol.c_str());
				break;
			default:									// ȊO
				break;
			}

			m_Log.m_srMsg.Format("SQL: %s", srSql.c_str());
			m_Log.fnPirnt(EG_LOG_DBG, __LINE__);
			// SQL̎s
			inRet = RtdbExecuteSql(m_hnCnDb, (char*)srSql.c_str(), woDBConTO);
			if (0 == inRet)
			{
				// s
				m_Log.m_srMsg.Format("Table Create %s", srDBConDbName.c_str());
				m_Log.fnPirnt(EG_LOG_OPE, __LINE__);
				m_tgMeasureId.m_unData.loVal = 1;			// vID̏
				m_tgMeasureId.fnWrite();					// ^Ȍ
				fnChangeState(EN_EgDBA_DB_STATE_MeasureIdCheck);			// DBԑJځFID`FbN
				boLpCont = true;											// [vԁFp
			}
			else
			{
				// ss
				// ͏I
				m_Log.m_srMsg.Format("Failed: Table Create %d", inRet);
				m_Log.fnPirnt(EG_LOG_ERR, __LINE__);
				m_tgDBAErr.m_unData.dwVal = inRet;								// G[R[h̍XV
				m_tgDBAErr.fnWrite();											//  ^Ȍ
				m_tgLastErr.m_unData.dwVal = ERR_EGDBA_DB_TABLE_CREATE;			// ŐVG[R[hXV
				m_tgLastErr.fnWrite();											// ^Ȍ
				// DBԑJځFȂ
				boLpCont = false;												// [vԁFI
				dwRet = m_tgLastErr.m_unData.dwVal;								// ُI
			}
			break;

		// ========================================
		// ID`FbN
		case EN_EgDBA_DB_STATE_MeasureIdCheck:
			// ő[̃`FbN
			if (0 < m_tgTableRecMax.m_unData.loVal)
			{
				// ő[w肠
				if (m_tgMeasureId.m_unData.loVal < m_tgTableRecMax.m_unData.loVal)
				{
					// ő[
					fnChangeState(EN_EgDBA_DB_STATE_DBTableInsert, false);		// DBԑJځFDBe[u}
					boLpCont = true;											// [vԁFp
					dwRet = ERR_EGDBA_OK;										// I
				}
				else
				{
					// ő[ȏ
					m_Log.m_srMsg.Format("Failed: Table Record Over Now=%d Max=%d", m_tgMeasureId.m_unData.loVal, m_tgTableRecMax.m_unData.loVal);
					m_Log.fnPirnt(EG_LOG_ERR, __LINE__);
					m_tgDBAErr.m_unData.dwVal = inRet;								// G[R[h̍XV
					m_tgDBAErr.fnWrite();											//  ^Ȍ
					m_tgLastErr.m_unData.dwVal = ERR_EGDBA_DB_MEASURE_ID_OVER;		// ŐVG[R[hXV
					m_tgLastErr.fnWrite();											// ^Ȍ
					// DBԑJځFȂ
					boLpCont = false;												// [vԁFI
					dwRet = m_tgLastErr.m_unData.dwVal;								// ُI
				}
			}
			else
			{
				// ő[wȂ
				fnChangeState(EN_EgDBA_DB_STATE_DBTableInsert, false);		// DBԑJځFDBe[u}
				boLpCont = true;											// [vԁFp
				dwRet = ERR_EGDBA_OK;										// I
			}
			break;

		// ========================================
		// DBe[u}
		case EN_EgDBA_DB_STATE_DBTableInsert:
			// RTCD̓ǂݍ
			for (szLp = 0; szLp < m_TagRefsOut.size(); szLp++)
			{
				if (m_TagRefsOut[szLp].m_tgTag.m_woSize == 0) { continue; }		// ^OTCYݒ͏O
				m_TagRefsOut[szLp].m_tgTag.fnRead();							// ^O̓ǂݍ
			}

			// SQL񖼂̐
			srSqlCol = "";
			srSqlCol.Format("%s, %s, %s, ", NM_EgDBA_TABLE_MEASURE_ID, NM_EgDBA_TABLE_MEASURE_DATE, NM_EgDBA_TABLE_MEASURE_MSEC);
			for (szLp = 0; szLp < m_TagRefsOut.size(); szLp++)
			{
				// ^Oo^mF
				if (m_TagRefsOut[szLp].m_tgTag.m_woSize == 0) { continue; }		// ^OTCYݒ͏O

				// ^Oǉ
				srSqlCol += m_TagRefsOut[szLp].m_tgTag.m_srName;
				// ŏI^Oǂ̔
				if ((szLp + 1) < m_TagRefsOut.size())
				{
					// ŏI^OłȂ߁Ã^Oo^󋵂ŃJ}̕t𔻒fB
					if (m_TagRefsOut[szLp + 1].m_tgTag.m_woSize != 0)
					{
						srSqlCol += ", ";					// ̃^Oo^Ă邽߁AJ}t
					}
				}
			}

			// VXe̎擾
			gettimeofday(&m_stTv, &m_stTz);
			m_stTm = localtime((const time_t *)&m_stTv.tv_sec);

			// SQLl̐
			srSqlVal = "";
			srSqlVal.Format("%d, '%04d-%02d-%02d %02d:%02d:%02d', %d, ", 
							m_tgMeasureId.m_unData.loVal,
							m_stTm->tm_year+1900, m_stTm->tm_mon+1, m_stTm->tm_mday,
							m_stTm->tm_hour, m_stTm->tm_min, m_stTm->tm_sec,
							m_stTv.tv_usec/1000);
			for (szLp = 0; szLp < m_TagRefsOut.size(); szLp++)
			{
				// ^Oo^mF
				if (m_TagRefsOut[szLp].m_tgTag.m_woSize == 0) { continue; }		// ^OTCYݒ͏O

				// SQLʂŕ
				switch (byDBType)
				{
				case EN_EGDBA_SQL_TYPE_MDB:					// MDB
				case EN_EGDBA_SQL_TYPE_SQLServer:			// SQLServer
					// f[^^ŕ
					switch (m_TagRefsOut[szLp].m_tgTag.m_woType)
					{
					case EgVtBoolean:	srTmp.Format("%d", m_TagRefsOut[szLp].m_tgTag.m_unData.boVal);	break;
					case EgVtSByte:		srTmp.Format("%d", m_TagRefsOut[szLp].m_tgTag.m_unData.chVal);	break;
					case EgVtByte:		srTmp.Format("%d", m_TagRefsOut[szLp].m_tgTag.m_unData.byVal);	break;
					case EgVtInt16:		srTmp.Format("%d", m_TagRefsOut[szLp].m_tgTag.m_unData.shVal);	break;
					case EgVtUInt16:	srTmp.Format("%d", m_TagRefsOut[szLp].m_tgTag.m_unData.woVal);	break;
					case EgVtInt32:		srTmp.Format("%d", m_TagRefsOut[szLp].m_tgTag.m_unData.loVal);	break;
					case EgVtFloat:		srTmp.Format("%f", m_TagRefsOut[szLp].m_tgTag.m_unData.flVal);	break;
					case EgVtDouble:	srTmp.Format("%f", m_TagRefsOut[szLp].m_tgTag.m_unData.doVal);	break;
					default:			srTmp = "0";														break;	// LȊO ... ftHgl
					}
					break;
				default:									// ȊO
					srTmp = "0";
					break;
				}
				srSqlVal += srTmp;						// ϊʂǉ

				// ŏI^Oǂ̔
				if ((szLp + 1) < m_TagRefsOut.size())
				{
					// ŏI^OłȂ߁Ã^Oo^󋵂ŃJ}̕t𔻒fB
					if (m_TagRefsOut[szLp + 1].m_tgTag.m_woSize != 0)
					{
						srSqlVal += ", ";					// ̃^Oo^Ă邽߁AJ}t
					}
				}
			}
			// SQL̐
			srSql.Format("insert into %s(%s) values(%s)", srDBConDbName.c_str(), srSqlCol.c_str(), srSqlVal.c_str());

			// SQL̎s
			inRet = RtdbExecuteSql(m_hnCnDb, (char*)srSql.c_str(), woDBConTO);
			if (0 == inRet)
			{
				// s
				m_tgMeasureId.m_unData.loVal++;						// vIDCNg
				m_tgMeasureId.fnWrite();							// ^Ȍ
				fnChangeState(EN_EgDBA_DB_STATE_MeasureIdCheck, false);		// DBԑJځFID`FbN
				boLpCont = false;											// [vԁFI
				dwRet = ERR_EGDBA_OK;										// I
			}
			else
			{
				// ss
				// ͏I
				m_Log.m_srMsg.Format("SQL: %s", srSql.c_str());
				m_Log.fnPirnt(EG_LOG_DBG, __LINE__);
				m_Log.m_srMsg.Format("Failed: Table Insert %d", inRet);
				m_Log.fnPirnt(EG_LOG_ERR, __LINE__);
				m_tgDBAErr.m_unData.dwVal = inRet;								// G[R[h̍XV
				m_tgDBAErr.fnWrite();											//  ^Ȍ
				m_tgLastErr.m_unData.dwVal = ERR_EGDBA_DB_TABLE_INSERT;			// ŐVG[R[hXV
				m_tgLastErr.fnWrite();											// ^Ȍ
				// DBԑJځFȂ
				boLpCont = false;												// [vԁFI
				dwRet = m_tgLastErr.m_unData.dwVal;								// ُI
			}
			break;

		// ========================================
		// TagRefs_OUT`FbNgC
		case EN_EgDBA_DB_STATE_TagRefsOUTRetry:
			// oߎԔ
			m_swBase.Stop();													// ԃX^[g
			if (m_tgTagCheckTimeout.m_unData.dwVal < (DWORD)m_swBase.GetSec())
			{
				// oߎԉ߂
				for (szLp = 0; szLp < m_TagRefsOut.size(); szLp++)
				{
					// 擾łȂ^OOo
					if ((EgVtEmpty == m_TagRefsOut[szLp].m_tgTag.m_woType) || (0 == m_TagRefsOut[szLp].m_tgTag.m_woSize))
					{
						m_Log.m_srMsg.Format("%s is not configured. Type=%02d Size=%02d", 
												m_TagRefsOut[szLp].m_tgTag.m_srName.c_str(),
												m_TagRefsOut[szLp].m_tgTag.m_woType,
												m_TagRefsOut[szLp].m_tgTag.m_woSize);
						m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
					}
				}
				fnChangeState(EN_EgDBA_DB_STATE_TagRefsOUTError);				// DBԑJځFTagRefs_OUT`FbNG[
				boLpCont = true;												// [vԁFp
				dwRet = ERR_EGDBA_OK;											// I
			}
			else
			{
				// oߎԉ߂ĂȂ
				fnChangeState(EN_EgDBA_DB_STATE_TagRefsOUTCheck, false);		// DBԑJځFTagRefs_OUT`FbN
				boLpCont = false;												// [vԁFI
				dwRet = ERR_EGDBA_OK;											// I
			}
			break;

		// ========================================
		// TagRefs_OUT`FbNG[
		case EN_EgDBA_DB_STATE_TagRefsOUTError:
			// DBI
			// DBԑJځFύXȂ
			boLpCont = false;												// [vԁFI
			m_tgLastErr.m_unData.dwVal = ERR_EGDBA_TAG_NO_CONFIG;			// ŐVG[R[hXV
			m_tgLastErr.fnWrite();											// ^Ȍ
			dwRet = m_tgLastErr.m_unData.dwVal;								// G[
			m_Log.m_srMsg.Format("Failed: Tag No Config 0x%08X", m_tgLastErr.m_unData.dwVal);
			m_Log.fnPirnt(EG_LOG_ERR, __LINE__);
			break;

		// ========================================
		// f[^^`FbN
		case EN_EgDBA_DB_STATE_TypeCheck:
			boCheckErr = false;													// ftHg̓`FbNʐ
			for (szLp = 0; szLp < m_TagRefsOut.size(); szLp++)
			{
				// SQLʂŕ
				switch (byDBType)
				{
				case EN_EGDBA_SQL_TYPE_MDB:					// MDB
				case EN_EGDBA_SQL_TYPE_SQLServer:			// SQLServer
					// f[^^ŕ
					switch (m_TagRefsOut[szLp].m_tgTag.m_woType)
					{
					case EgVtBoolean:
					case EgVtSByte:
					case EgVtByte:
					case EgVtInt16:
					case EgVtUInt16:
					case EgVtInt32:
					case EgVtFloat:
					case EgVtDouble:
						// T|[g̃^O^
						break;
					default:													// LȊO
						// T|[g̃^O^
						boCheckErr = true;										// `FbNʈُ
						m_TagRefsOut[szLp].m_tgTag.m_woType = EgVtEmpty;		// ^O^CvftHglɃZbg
						m_TagRefsOut[szLp].m_tgTag.m_woSize = 0;				// ^OTCYftHglɃZbg
						m_Log.m_srMsg.Format("%s type:%02d size:%02d is not support", 
												m_TagRefsOut[szLp].m_tgTag.m_srName.c_str(),
												m_TagRefsOut[szLp].m_tgTag.m_woType,
												m_TagRefsOut[szLp].m_tgTag.m_woSize);
						m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
						break;
					}
					break;
				default:									// ȊO
					boCheckErr = true;
					m_Log.m_srMsg.Format("SQLType:%02d is not support", byDBType);
					m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
					break;
				}
			}
			// `FbNʔ
			if (true == boCheckErr)
			{
				// ُ
				fnChangeState(EN_EgDBA_DB_STATE_TypeCheckError);				// DBԑJځFf[^^`FbNG[
				boLpCont = true;												// [vԁFp
				dwRet = ERR_EGDBA_OK;											// I
			}
			else
			{
				// 
				fnChangeState(EN_EgDBA_DB_STATE_DBOpen);						// DBԑJځFDBI[v
				boLpCont = true;												// [vԁFp
				dwRet = ERR_EGDBA_OK;											// I
			}
			break;

		// ========================================
		// f[^^`FbNG[
		case EN_EgDBA_DB_STATE_TypeCheckError:
			// ^Oo^s̓씻
			// DBԑJځFύXȂ
			boLpCont = false;												// [vԁFI
			m_tgLastErr.m_unData.dwVal = ERR_EGDBA_TAG_TYPE_NOT_SUPPORT;	// ŐVG[R[hXV
			m_tgLastErr.fnWrite();											// ^Ȍ
			dwRet = m_tgLastErr.m_unData.dwVal;								// G[
			m_Log.m_srMsg.Format("Failed: Tag Type Not Support 0x%08X", m_tgLastErr.m_unData.dwVal);
			m_Log.fnPirnt(EG_LOG_ERR, __LINE__);
			break;

		// ========================================
		// 擾R[h
		case EN_EgDBA_DB_STATE_DBTableRecCheck:
			// 擾R[h
			if (0 < dwRecCnt)
			{
				// R[ho^ς
				fnChangeState(EN_EgDBA_DB_STATE_DBTableConfigCheck);			// DBԑJځFDBe[u\mF
				boLpCont = true;												// [vԁFp
				dwRet = ERR_EGDBA_OK;											// I
			}
			else
			{
				// R[ho^
				fnChangeState(EN_EgDBA_DB_STATE_DBTableDelete);					// DBԑJځFDBe[u폜
				boLpCont = true;												// [vԁFp
				dwRet = ERR_EGDBA_OK;											// I
			}
			break;




		// ========================================
		// LȊO͖
		default:
			m_Log.m_srMsg.Format("Failed: DB State %02d Not Support", m_tgState.m_unData.dwVal);
			m_Log.fnPirnt(EG_LOG_ERR, __LINE__);
			boLpCont = false;													// [vԁFI
			break;
		}

		// ========================================
		// [v񐔔
		if (dwLpCnt < dwLpMax)
		{
			dwLpCnt++;
		}
		else
		{
			// DBXs([v񐔂ő񐔒)
			m_Log.m_srMsg.Format("Failed: DB State %02d Spin", m_tgState.m_unData.dwVal);
			m_Log.fnPirnt(EG_LOG_ERR, __LINE__);
			boLpCont = false;													// [vԁFI
			m_tgLastErr.m_unData.dwVal = ERR_EGDBA_DB_STATE_SPIN;				// ŐVG[R[hXV
			m_tgLastErr.fnWrite();												// ^Ȍ
			dwRet = m_tgLastErr.m_unData.dwVal;
		}

		// ========================================
		// [vI
		if (boLpCont == false)
		{
			// [vI
			break;
		}

	}




	return dwRet;
}

// ------------------------------------------------------------
// N[Y
void	CThreadDB::fnClose()
{
	// ڑԔ
	if (m_tgConnected.m_unData.boVal == FALSE) { return; }		// ڑ̂߁AI

	// DBN[Y
	RtdbDisconnect(m_hnCnDb, woDBConTO);
	m_Log.m_srMsg.Format("Close");
	m_Log.fnPirnt(EG_LOG_OPE, __LINE__);

	m_tgConnectedClose.m_unData.dwVal++;						// Close񐔃CNg
	m_tgConnectedClose.fnWrite();								// ^Ȍ

	m_tgConnected.m_unData.boVal = FALSE;						// ڑԍXV
	m_tgConnected.fnWrite();									// ^Ȍ

}

// ------------------------------------------------------------
// Xbh㏈
int		CThreadDB::ExitInstance(void)
{
	m_Log.m_srMsg.Format("Failed: Waitfor %s 0x%04X", m_srNmSem.c_str(), m_status);
	m_Log.fnPirnt(EG_LOG_ERR, __LINE__);

	m_tgLastErr.m_unData.dwVal = ERR_EGDBA_RECV_TRG_SLAVE;		// ŐVG[R[hXV
	m_tgLastErr.fnWrite();										// ^Ȍ

	fnClose();													// N[Y

	m_tgSuspend.m_unData.boVal = TRUE;							// NԍXV
	m_tgSuspend.fnWrite();										// ^Ȍ

	// NXR[
	return CISemaphoreThread::ExitInstance();
}


