///////////////////////////////////////////////////////////////////////
// implementation of the CIPollThread class
// last updated: 28oct98
// Copyright(C) 1998 Micronet Co. All Rights Reserved.


#include "rtpp.h"


///////////////////////////////////////////////////////////////////////
// constructor

CIPollThread::		CIPollThread(void)

	: CIThread()
{
}


///////////////////////////////////////////////////////////////////////
// Create
// returns: zero or error code

DWORD CIPollThread::Create(
	char *				pszName,
	DWORD				dwTime,
	BYTE				byPrio,
	DWORD				dwStack,
	BOOL				bGo)
{
	m_dwTime		= dwTime;

	CIThread::Create(pszName, byPrio, dwStack, bGo);

	return m_status;
}


///////////////////////////////////////////////////////////////////////
// SetPoll

void CIPollThread::	SetPoll(
	DWORD				dwTime)
{
	m_dwTime		= dwTime;
}


///////////////////////////////////////////////////////////////////////
// DoForever
// returns: TRUE if loop should continue, FALSE if thread should terminate

BOOL CIPollThread::	DoForever(void)
{
	RtSleep(m_dwTime);
	return OnPoll();
}


///////////////////////////////////////////////////////////////////////

BOOL CIPollThread::	OnPoll(void)
{
	return TRUE;
}
