/*****************************************************************************
*
* FILE NAME:		DriverInterface.cpp
*
* DESCRIPTION:	ėpINtimehCoC^[tF[XbZ[WLANX
*
* REMARKS:			̃NXINtimehCoC^[tF[XŎgp
*					bZ[WLANX̎[Ă܂B
*					̃NX̓VXeɈˑȂdg݂ō쐬Ă܂B
*					VXeɈˑ鏈DriverInterfaceMsgɍ쐬ĂB
*
*               Copyright(C) 2020 Micronet Co. All Rights Reserved.
\*****************************************************************************/
#include "DriverIfMsgCarrier.h"

// ------------------------------------------------------------
// RXgN^
CDriverIfMsgCarrier::CDriverIfMsgCarrier()
{
}

// ------------------------------------------------------------
// fXgN^
CDriverIfMsgCarrier::~CDriverIfMsgCarrier()
{
}

// ------------------------------------------------------------
// hCoNGXgpPbg\z
void CDriverIfMsgCarrier::SetRequest(DWORD control, DWORD size, LPVOID data)
{
	GetHead()->dwControlCode	= control;
	GetHead()->dwStatusCode		= 0;
	GetHead()->dwContentSize	= size;
	if( size && data )
		memcpy( GetContent() ,data ,size );
}

// ------------------------------------------------------------
// hCoAT[pPbg\z
void CDriverIfMsgCarrier::SetAnswer(DWORD status, DWORD size, LPVOID data)
{
	GetHead()->dwStatusCode = status;
	GetHead()->dwContentSize = size;
	if (size && data)
		memcpy(GetContent(), data, size);
}

// ------------------------------------------------------------
// hCoNGXgpPbg擾
void CDriverIfMsgCarrier::GetRequest(DWORD * control, DWORD * size, LPVOID data)
{
	*control = GetHead()->dwControlCode;
	if (size)
	{
		*size = GetHead()->dwContentSize;
		if (*size && data)
			memcpy(data, GetContent(), *size);
	}
}

// ------------------------------------------------------------
// hCoAT[pPbg擾
void CDriverIfMsgCarrier::GetAnswer(DWORD * status, DWORD * size, LPVOID data)
{
	*status = GetHead()->dwStatusCode;
	if (size)
	{
		*size = GetHead()->dwContentSize;
		if (*size && data)
			memcpy(data, GetContent(), *size);
	}
}

// ------------------------------------------------------------
// wb_̃|C^擾
ST_DIFMCP * CDriverIfMsgCarrier::GetHead(void)
{
	return (ST_DIFMCP*)GetPointer();
}

// ------------------------------------------------------------
// wb_TCY擾
DWORD CDriverIfMsgCarrier::GetHeadSize(void)
{
	return sizeof(ST_DIFMCP) - sizeof(BYTE);
}

// ------------------------------------------------------------
// f[^Rec̃|C^擾
LPVOID CDriverIfMsgCarrier::GetContent(void)
{
	return GetHead()->byData;
}

// ------------------------------------------------------------
// RecTCY擾
DWORD CDriverIfMsgCarrier::GetContentSize(void)
{
	return GetHead()->dwContentSize;
}

