/*****************************************************************************
*
* FILE NAME:		DriverInterface.h
*
* DESCRIPTION:	ėpINtimehCoC^[tF[XbZ[WLANX
*
* REMARKS:			̃NXINtimehCoC^[tF[XŎgp
*					bZ[WLANX̎[Ă܂B
*					̃NX̓VXeɈˑȂdg݂ō쐬Ă܂B
*					VXeɈˑ鏈DriverInterfaceMsgɍ쐬ĂB
*
*               Copyright(C) 2020 Micronet Co. All Rights Reserved.
\*****************************************************************************/
#pragma once
#include <rtpp.h>
#include <stdio.h>
#include <string.h>
#include <syslog.h>

// ------------------------------------------------------------
// hCoC^[tF[XbZ[WLApPbg
//	(DIFCP: Driver InterFace Carrier Packet)
// ------------------------------------------------------------
#pragma pack(push,1)
typedef struct TG_DIFMCP {
	DWORD		dwControlCode;			// Rg[R[h
	DWORD		dwStatusCode;			// Xe[^XR[h
	DWORD		dwContentSize;			// RecTCY
	BYTE		byData[1];				// f[^Rec
}	ST_DIFMCP;
#pragma pack(pop)


// ------------------------------------------------------------
// hCoC^[tF[XbZ[WLA
// ------------------------------------------------------------
class CDriverIfMsgCarrier : public CIMemory
{
private:

public:
	// ------------------------------------------------------------
	// RXgN^
	// [param]
	//		Ȃ
	// [return]
	//		Ȃ
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	CDriverIfMsgCarrier();

	// ------------------------------------------------------------
	// fXgN^
	// [param]
	//		Ȃ
	// [return]
	//		Ȃ
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	~CDriverIfMsgCarrier();

	// ------------------------------------------------------------
	// hCoNGXgpPbg\z
	// [param]
	//		control ... Rg[R[h
	//		size    ... RecTCY
	//		data    ... f[^Rec
	// [return]
	//		Ȃ
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	void SetRequest(DWORD control, DWORD size, LPVOID data);

	// ------------------------------------------------------------
	// hCoAT[pPbg\z
	// [param]
	//		status  ... Xe[^XR[h
	//		size    ... RecTCY
	//		data    ... f[^Rec
	// [return]
	//		Ȃ
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	void SetAnswer(DWORD status, DWORD size, LPVOID data);

	// ------------------------------------------------------------
	// hCoNGXgpPbg擾
	// [param]
	//		control ... Rg[R[h
	//		size    ... RecTCY
	//		data    ... f[^Rec
	// [return]
	//		Ȃ
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	void GetRequest(DWORD *control, DWORD *size, LPVOID data);

	// ------------------------------------------------------------
	// hCoAT[pPbg擾
	// [param]
	//		status  ... Xe[^XR[h
	//		size    ... RecTCY
	//		data    ... f[^Rec
	// [return]
	//		Ȃ
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	void GetAnswer(DWORD *status, DWORD *size, LPVOID data);

	// ------------------------------------------------------------
	// wb_̃|C^擾
	// [param]
	//		Ȃ
	// [return]
	//		wb_|C^
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	ST_DIFMCP *GetHead(void);

	// ------------------------------------------------------------
	// wb_TCY擾
	// [param]
	//		Ȃ
	// [return]
	//		wb_TCY
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	DWORD GetHeadSize(void);

	// ------------------------------------------------------------
	// f[^Rec̃|C^擾
	// [param]
	//		Ȃ
	// [return]
	//		f[^Rec|C^
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	LPVOID GetContent(void);

	// ------------------------------------------------------------
	// RecTCY擾
	// [param]
	//		Ȃ
	// [return]
	//		RecTCY
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	DWORD GetContentSize(void);

};
