/*****************************************************************************
*
* FILE NAME:		MemoryPool.cpp
*
* DESCRIPTION:	ėpINtimehCoC^[tF[Xv[NX
*
* REMARKS:			̃NXINtimehCoC^[tF[XŎgp
*					v[NX̎[Ă܂B
*					̃NX̓VXeɈˑȂdg݂ō쐬Ă܂B
*					VXeɈˑ鏈DriverInterfaceMsgɍ쐬ĂB
*
*               Copyright(C) 2020 Micronet Co. All Rights Reserved.
\*****************************************************************************/
#include "MemoryPool.h"

// ------------------------------------------------------------
// RXgN^
CIMemoryPool::CIMemoryPool()
{
	m_MemArray = 0;
}

// ------------------------------------------------------------
// fXgN^
CIMemoryPool::~CIMemoryPool()
{
	DeletePool();
}

// ------------------------------------------------------------
// v[̐
bool CIMemoryPool::MakePool(int iNumQue, DWORD dwSizePacket)
{
	CIMemory	*newpacket;
	DWORD		dwRet;
	int			lp1;

	m_NumQue = iNumQue;
	m_SizePacket = dwSizePacket;

	// create memory pool mailbox
	dwRet = Create("");
	if (dwRet != E_OK)
		goto err;

	// make memory pool 
	m_MemArray = new CIMemory*[m_NumQue];
	for (lp1 = 0; lp1 < m_NumQue; lp1++)
	{
		// create a memory 
		newpacket = m_MemArray[lp1] = new CIMemory();
		dwRet = newpacket->Create("", m_SizePacket);
		if (dwRet != E_OK)
			goto err;

		// queue memory
		dwRet = Send(newpacket);
		if (dwRet != E_OK)
			goto err;
	}

	return true;

err:
	DeletePool();
	return false;
}

// ------------------------------------------------------------
// v[̍폜
bool CIMemoryPool::DeletePool()
{
	int		lp1;

	// delete memory pool
	if (m_MemArray)
	{
		for (lp1 = 0; lp1 < m_NumQue; lp1++)
		{
			delete m_MemArray[lp1];
		}
		delete[] m_MemArray;
	}
	m_MemArray = 0;;
	return true;
}

// ------------------------------------------------------------
// v[pPbgp1o
CIMemory * CIMemoryPool::PickPool()
{
	return (CIMemory*)Receive((DWORD)0);
}

// ------------------------------------------------------------
// v[Ƀԋp
bool CIMemoryPool::ReturnPool(CIMemory * mem)
{
	DWORD	dwRet;

	if (!mem)
		return false;

	dwRet = Send(mem);

	delete mem;

	return (dwRet != E_OK) ? false : true;
}

